;**************************************************************
;* File: lab_8.asm                                            *
;* Author: Chris Szilagyi                                     *
;* Desc: This file contains a skeleton for lab 8 to declare   *
;*       the wiper controller functionality and the serial    *
;*       interrupt handler.                                   *
;* Date: 10-12-2009                                           *
;**************************************************************

; export symbols
; TODO: export assembly functions.  wiper_init has been done as an example.
;       Also, make sure to declare function prototypes in main_asm.h
            XDEF wiper_init

; TODO: Declare sciRxBuf as an external reference


            ; we use export 'Entry' as symbol. This allows us to
            ; reference 'Entry' either in the linker .prm file
            ; or from C/C++ later on

; Include derivative-specific definitions 
		INCLUDE 'derivative.inc'  		

		    
; variable/data section
MY_EXTENDED_RAM: SECTION
; Insert here your data definition. For demonstration, temp_byte is used.
;*************************************************
; ADD GLOBAL VARIABLES HERE
;*************************************************

; TODO:  Declare all constants and global variables for the wiper controller

; code section
MyCode:     SECTION
; this assembly routine is called by the C/C++ application

;*****************************************************
; ADD CODE HERE
;*****************************************************

;---------------------
;MAIN CODE STARTS HERE



;---------------------
;INITILIZATION

;TODO
            ;Wiper controller initilization
            ; Do any IOInit for wiper controller
            ; Call wiperUpdateInit
            ; Set ControllerState to StateOff
wiper_init:

            RTS
;---------------------
;BEGIN STATE LOOP


;TODO
            ;Implement a single iteration of the stateLoop from Lab 3
            ; Instead of jumping back to the top of the state loop
            ; return from the subroutine.  
            ;Add ALL code necessary to implement the wiper controller
            ; from lab 3.

wiper_main:

            RTS
;---------------------
;INTERRUPT DECLARATIONS

;-----------------------------------------
; sci_handle - Serial Handler
; NOTE:  This function will flip Port B RDRF_INDICATOR on and off 
;        to indicate the amount of time spent in this function.
;        Also, don't forget to declare the interrupt vector
;-----------------------------------------
 
sci_handle:

            
            LDAA #$40     ;Turn on RDRF_INDICATOR on Port B
            ORAA PORTB
            STAA PORTB            

            
;TODO:  Implement the serial interrupt handler
;       Copy the newest byte received into the buffer variable sciRxBuf
;NOTE: All code for this function must appear between BEGIN_serial and END_serial            
;BEGIN_serial


;END_serial
            JSR sleep5ms  ;Delay for 5 ms
            LDAA #$40     ;Turn off RDRF_INDICATOR on Port B
            COMA
            ANDA PORTB
            STAA PORTB

            RTI           ;Return.  End of interrupt



;-----------------------------------------
;sleep5ms - Five millisecond delay.  Note, this is not necessary to
;           make the UART interrupt work.  This is used for illustrating
;           timing issues in Lab 8 Part 4.
;-----------------------------------------


sleep5ms:
            PSHX
            LDX #0
sleepLoop:
            INX
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP            

            CPX #$0931  
            
            BNE sleepLoop
            PULX
            

            RTS


;*****************************************************
; DEFINE ISR VECTOR ADDRESSES HERE
;*****************************************************

; TODO - place sci_handle address in SCI interrupt vector


